Index: uspace/lib/inet/test/addr.c
===================================================================
--- uspace/lib/inet/test/addr.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
+++ uspace/lib/inet/test/addr.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -0,0 +1,199 @@
+/*
+ * Copyright (c) 2024 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <errno.h>
+#include <inet/addr.h>
+#include <pcut/pcut.h>
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(addr);
+
+/** Test inet_addr_parse() with unabbreviated address */
+PCUT_TEST(inet_addr_parse_full)
+{
+	errno_t rc;
+	inet_addr_t addr;
+	char *endptr;
+
+	rc = inet_addr_parse("1122:3344:5566:7788:99aa:bbcc:ddee:ff00/", &addr,
+	    &endptr);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS('/', *endptr);
+
+	PCUT_ASSERT_INT_EQUALS(ip_v6, addr.version);
+
+	PCUT_ASSERT_INT_EQUALS(0x11, addr.addr6[0]);
+	PCUT_ASSERT_INT_EQUALS(0x22, addr.addr6[1]);
+	PCUT_ASSERT_INT_EQUALS(0x33, addr.addr6[2]);
+	PCUT_ASSERT_INT_EQUALS(0x44, addr.addr6[3]);
+	PCUT_ASSERT_INT_EQUALS(0x55, addr.addr6[4]);
+	PCUT_ASSERT_INT_EQUALS(0x66, addr.addr6[5]);
+	PCUT_ASSERT_INT_EQUALS(0x77, addr.addr6[6]);
+	PCUT_ASSERT_INT_EQUALS(0x88, addr.addr6[7]);
+
+	PCUT_ASSERT_INT_EQUALS(0x99, addr.addr6[8]);
+	PCUT_ASSERT_INT_EQUALS(0xaa, addr.addr6[9]);
+	PCUT_ASSERT_INT_EQUALS(0xbb, addr.addr6[10]);
+	PCUT_ASSERT_INT_EQUALS(0xcc, addr.addr6[11]);
+	PCUT_ASSERT_INT_EQUALS(0xdd, addr.addr6[12]);
+	PCUT_ASSERT_INT_EQUALS(0xee, addr.addr6[13]);
+	PCUT_ASSERT_INT_EQUALS(0xff, addr.addr6[14]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[15]);
+}
+
+/** Test inet_addr_parse() with short groups (< 0x1000) */
+PCUT_TEST(inet_addr_parse_shortgr)
+{
+	errno_t rc;
+	inet_addr_t addr;
+	char *endptr;
+
+	rc = inet_addr_parse("1:22:333:4444:5:66:777:8888/", &addr,
+	    &endptr);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS('/', *endptr);
+
+	PCUT_ASSERT_INT_EQUALS(ip_v6, addr.version);
+
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[0]);
+	PCUT_ASSERT_INT_EQUALS(0x01, addr.addr6[1]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[2]);
+	PCUT_ASSERT_INT_EQUALS(0x22, addr.addr6[3]);
+	PCUT_ASSERT_INT_EQUALS(0x03, addr.addr6[4]);
+	PCUT_ASSERT_INT_EQUALS(0x33, addr.addr6[5]);
+	PCUT_ASSERT_INT_EQUALS(0x44, addr.addr6[6]);
+	PCUT_ASSERT_INT_EQUALS(0x44, addr.addr6[7]);
+
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[8]);
+	PCUT_ASSERT_INT_EQUALS(0x05, addr.addr6[9]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[10]);
+	PCUT_ASSERT_INT_EQUALS(0x66, addr.addr6[11]);
+	PCUT_ASSERT_INT_EQUALS(0x07, addr.addr6[12]);
+	PCUT_ASSERT_INT_EQUALS(0x77, addr.addr6[13]);
+	PCUT_ASSERT_INT_EQUALS(0x88, addr.addr6[14]);
+	PCUT_ASSERT_INT_EQUALS(0x88, addr.addr6[15]);
+}
+
+/** Test inet_addr_parse() with wildcard at the beginning */
+PCUT_TEST(inet_addr_parse_wcbegin)
+{
+	errno_t rc;
+	inet_addr_t addr;
+	char *endptr;
+
+	rc = inet_addr_parse("::1234/", &addr, &endptr);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS('/', *endptr);
+
+	PCUT_ASSERT_INT_EQUALS(ip_v6, addr.version);
+
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[0]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[1]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[2]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[3]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[4]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[5]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[6]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[7]);
+
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[8]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[9]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[10]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[11]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[12]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[13]);
+	PCUT_ASSERT_INT_EQUALS(0x12, addr.addr6[14]);
+	PCUT_ASSERT_INT_EQUALS(0x34, addr.addr6[15]);
+}
+
+/** Test inet_addr_parse() with wildcard in the middle */
+PCUT_TEST(inet_addr_parse_wcmiddle)
+{
+	errno_t rc;
+	inet_addr_t addr;
+	char *endptr;
+
+	rc = inet_addr_parse("1122:3344::5566/", &addr, &endptr);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS('/', *endptr);
+
+	PCUT_ASSERT_INT_EQUALS(ip_v6, addr.version);
+
+	PCUT_ASSERT_INT_EQUALS(0x11, addr.addr6[0]);
+	PCUT_ASSERT_INT_EQUALS(0x22, addr.addr6[1]);
+	PCUT_ASSERT_INT_EQUALS(0x33, addr.addr6[2]);
+	PCUT_ASSERT_INT_EQUALS(0x44, addr.addr6[3]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[4]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[5]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[6]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[7]);
+
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[8]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[9]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[10]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[11]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[12]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[13]);
+	PCUT_ASSERT_INT_EQUALS(0x55, addr.addr6[14]);
+	PCUT_ASSERT_INT_EQUALS(0x66, addr.addr6[15]);
+}
+
+/** Test inet_addr_parse() with wildcard at the end */
+PCUT_TEST(inet_addr_parse_wcend)
+{
+	errno_t rc;
+	inet_addr_t addr;
+	char *endptr;
+
+	rc = inet_addr_parse("1234:5678::/", &addr, &endptr);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS('/', *endptr);
+
+	PCUT_ASSERT_INT_EQUALS(ip_v6, addr.version);
+
+	PCUT_ASSERT_INT_EQUALS(0x12, addr.addr6[0]);
+	PCUT_ASSERT_INT_EQUALS(0x34, addr.addr6[1]);
+	PCUT_ASSERT_INT_EQUALS(0x56, addr.addr6[2]);
+	PCUT_ASSERT_INT_EQUALS(0x78, addr.addr6[3]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[4]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[5]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[6]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[7]);
+
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[8]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[9]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[10]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[11]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[12]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[13]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[14]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[15]);
+}
+
+PCUT_EXPORT(addr);
Index: uspace/lib/inet/test/main.c
===================================================================
--- uspace/lib/inet/test/main.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/lib/inet/test/main.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -31,4 +31,5 @@
 PCUT_INIT;
 
+PCUT_IMPORT(addr);
 PCUT_IMPORT(eth_addr);
 
Index: uspace/lib/label/src/gpt.c
===================================================================
--- uspace/lib/label/src/gpt.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/lib/label/src/gpt.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -443,5 +443,5 @@
 		gpt_hdr->first_usable_lba = host2uint64_t_le(ba_min);
 		gpt_hdr->last_usable_lba = host2uint64_t_le(ba_max);
-		uuid_encode(&disk_uuid, gpt_hdr->disk_guid);
+		uuid_encode_le(&disk_uuid, gpt_hdr->disk_guid);
 		gpt_hdr->entry_lba = host2uint64_t_le(ptba[i]);
 		gpt_hdr->num_entries = host2uint32_t_le(num_entries);
@@ -812,6 +812,6 @@
 
 	memset(pte, 0, sizeof(gpt_entry_t));
-	uuid_encode(&part->ptype.t.uuid, pte->part_type);
-	uuid_encode(&part->part_uuid, pte->part_id);
+	uuid_encode_le(&part->ptype.t.uuid, pte->part_type);
+	uuid_encode_le(&part->part_uuid, pte->part_id);
 	pte->start_lba = host2uint64_t_le(part->block0);
 	pte->end_lba = host2uint64_t_le(eblock);
@@ -849,6 +849,6 @@
 	part->nblocks = b1 - b0 + 1;
 	part->ptype.fmt = lptf_uuid;
-	uuid_decode(pte->part_type, &part->ptype.t.uuid);
-	uuid_decode(pte->part_id, &part->part_uuid);
+	uuid_decode_le(pte->part_type, &part->ptype.t.uuid);
+	uuid_decode_le(pte->part_id, &part->part_uuid);
 
 	part->label = label;
Index: uspace/lib/meson.build
===================================================================
--- uspace/lib/meson.build	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/lib/meson.build	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -112,4 +112,5 @@
 	'virtio',
 
+	'ata',
 	'ieee80211',
 	'ddev',
Index: uspace/lib/ui/include/types/ui/menubar.h
===================================================================
--- uspace/lib/ui/include/types/ui/menubar.h	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/lib/ui/include/types/ui/menubar.h	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -40,4 +40,12 @@
 typedef struct ui_menu_bar ui_menu_bar_t;
 
+/** Menu bar callbacks */
+typedef struct ui_menu_bar_cb {
+	/** Activated */
+	void (*activate)(ui_menu_bar_t *, void *);
+	/** Deactivated */
+	void (*deactivate)(ui_menu_bar_t *, void *);
+} ui_menu_bar_cb_t;
+
 #endif
 
Index: uspace/lib/ui/include/ui/menubar.h
===================================================================
--- uspace/lib/ui/include/ui/menubar.h	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/lib/ui/include/ui/menubar.h	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2023 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -52,4 +52,5 @@
     ui_menu_bar_t **);
 extern void ui_menu_bar_destroy(ui_menu_bar_t *);
+extern void ui_menu_bar_set_cb(ui_menu_bar_t *, ui_menu_bar_cb_t *, void *);
 extern ui_control_t *ui_menu_bar_ctl(ui_menu_bar_t *);
 extern void ui_menu_bar_set_rect(ui_menu_bar_t *, gfx_rect_t *);
Index: uspace/lib/ui/private/menubar.h
===================================================================
--- uspace/lib/ui/private/menubar.h	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/lib/ui/private/menubar.h	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2023 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -64,4 +64,8 @@
 	/** List of menu drop-downs (ui_menu_dd_t) */
 	list_t menudds;
+	/** Callbacks */
+	struct ui_menu_bar_cb *cb;
+	/** Callback argument */
+	void *arg;
 };
 
Index: uspace/lib/ui/src/menubar.c
===================================================================
--- uspace/lib/ui/src/menubar.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/lib/ui/src/menubar.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2023 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -66,4 +66,6 @@
 static ui_evclaim_t ui_menu_bar_ctl_kbd_event(void *, kbd_event_t *);
 static ui_evclaim_t ui_menu_bar_ctl_pos_event(void *, pos_event_t *);
+static void ui_menu_bar_activate_ev(ui_menu_bar_t *);
+static void ui_menu_bar_deactivate_ev(ui_menu_bar_t *);
 
 /** Menu bar control ops */
@@ -131,4 +133,16 @@
 	ui_control_delete(mbar->control);
 	free(mbar);
+}
+
+/** Set menu bar callbacks.
+ *
+ * @param mbar Menu bar
+ * @param cb Callbacks
+ * @param arg Callback argument
+ */
+void ui_menu_bar_set_cb(ui_menu_bar_t *mbar, ui_menu_bar_cb_t *cb, void *arg)
+{
+	mbar->cb = cb;
+	mbar->arg = arg;
 }
 
@@ -288,6 +302,10 @@
 		}
 
+		if (!mbar->active)
+			ui_menu_bar_activate_ev(mbar);
 		mbar->active = true;
 	} else {
+		if (mbar->active)
+			ui_menu_bar_deactivate_ev(mbar);
 		mbar->active = false;
 	}
@@ -640,4 +658,5 @@
 
 	(void) ui_menu_bar_paint(mbar);
+	ui_menu_bar_activate_ev(mbar);
 }
 
@@ -649,4 +668,5 @@
 {
 	ui_menu_bar_select(mbar, NULL, false, 0);
+	ui_menu_bar_deactivate_ev(mbar);
 }
 
@@ -700,4 +720,24 @@
 }
 
+/** Send menu bar activate event.
+ *
+ * @param mbar Menu bar
+ */
+static void ui_menu_bar_activate_ev(ui_menu_bar_t *mbar)
+{
+	if (mbar->cb != NULL && mbar->cb->activate != NULL)
+		mbar->cb->activate(mbar, mbar->arg);
+}
+
+/** Send menu bar deactivate event.
+ *
+ * @param mbar Menu bar
+ */
+static void ui_menu_bar_deactivate_ev(ui_menu_bar_t *mbar)
+{
+	if (mbar->cb != NULL && mbar->cb->deactivate != NULL)
+		mbar->cb->deactivate(mbar, mbar->arg);
+}
+
 /** @}
  */
Index: uspace/lib/ui/src/window.c
===================================================================
--- uspace/lib/ui/src/window.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/lib/ui/src/window.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2023 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -318,4 +318,5 @@
 {
 	ui_window_t *window;
+	ui_window_t *pwindow = NULL;
 	display_info_t info;
 	gfx_coord2_t scr_dims;
@@ -505,5 +506,15 @@
 	*rwindow = window;
 
+	if (ui_is_fullscreen(ui))
+		pwindow = ui_window_get_active(ui);
+
 	list_append(&window->lwindows, &ui->windows);
+
+	if (ui_is_fullscreen(ui)) {
+		/* Send unfocus event to previously active window */
+		if (pwindow != NULL)
+			ui_window_send_unfocus(pwindow, 0);
+	}
+
 	return EOK;
 error:
@@ -531,4 +542,5 @@
 {
 	ui_t *ui;
+	ui_window_t *nwindow;
 
 	if (window == NULL)
@@ -558,4 +570,8 @@
 	if (ui_is_fullscreen(ui)) {
 		ui_paint(ui);
+		/* Send focus event to newly active window */
+		nwindow = ui_window_get_active(ui);
+		if (nwindow != NULL)
+			ui_window_send_focus(nwindow, 0);
 	}
 
Index: uspace/lib/usbhost/src/hcd.c
===================================================================
--- uspace/lib/usbhost/src/hcd.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/lib/usbhost/src/hcd.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -95,9 +95,11 @@
  * TODO: Make the bus mechanism less flexible in irq handling and remove the
  * lookup.
- */
-static void irq_handler(ipc_call_t *call, ddf_dev_t *dev)
-{
-	assert(dev);
-	hc_device_t *hcd = dev_to_hcd(dev);
+ *
+ * @param call Interrupt notification
+ * @param arg Argument (hc_device_t *)
+ */
+static void irq_handler(ipc_call_t *call, void *arg)
+{
+	hc_device_t *hcd = (hc_device_t *)arg;
 
 	const uint32_t status = ipc_get_arg1(call);
@@ -178,5 +180,5 @@
 	cap_irq_handle_t ihandle;
 	ret = register_interrupt_handler(hcd->ddf_dev, irq, irq_handler,
-	    &irq_code, &ihandle);
+	    (void *)hcd, &irq_code, &ihandle);
 	irq_code_clean(&irq_code);
 	if (ret != EOK) {
Index: uspace/srv/bd/vbd/disk.c
===================================================================
--- uspace/srv/bd/vbd/disk.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/srv/bd/vbd/disk.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2023 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -499,5 +499,5 @@
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "block_init(%zu)", sid);
-	rc = block_init(sid, 2048);
+	rc = block_init(sid);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed opening block device %s.",
Index: uspace/srv/fs/cdfs/cdfs_ops.c
===================================================================
--- uspace/srv/fs/cdfs/cdfs_ops.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/srv/fs/cdfs/cdfs_ops.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2011 Martin Decky
  * All rights reserved.
@@ -1093,5 +1094,5 @@
 
 	/* Initialize the block layer */
-	errno_t rc = block_init(service_id, BLOCK_SIZE);
+	errno_t rc = block_init(service_id);
 	if (rc != EOK)
 		return rc;
@@ -1150,5 +1151,5 @@
 {
 	/* Initialize the block layer */
-	errno_t rc = block_init(service_id, BLOCK_SIZE);
+	errno_t rc = block_init(service_id);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/fs/exfat/exfat_ops.c
===================================================================
--- uspace/srv/fs/exfat/exfat_ops.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/srv/fs/exfat/exfat_ops.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2008 Jakub Jermar
  * Copyright (c) 2011 Oleg Romanenko
@@ -1020,5 +1021,5 @@
 
 	/* initialize libblock */
-	rc = block_init(service_id, BS_SIZE);
+	rc = block_init(service_id);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/fs/fat/fat_ops.c
===================================================================
--- uspace/srv/fs/fat/fat_ops.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/srv/fs/fat/fat_ops.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2008 Jakub Jermar
  * Copyright (c) 2011 Oleg Romanenko
@@ -916,5 +917,5 @@
 
 	/* initialize libblock */
-	rc = block_init(service_id, BS_SIZE);
+	rc = block_init(service_id);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/fs/mfs/mfs_ops.c
===================================================================
--- uspace/srv/fs/mfs/mfs_ops.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/srv/fs/mfs/mfs_ops.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2011 Maurizio Lombardi
  * All rights reserved.
@@ -283,5 +284,5 @@
 
 	/* Initialize libblock */
-	rc = block_init(service_id, 4096);
+	rc = block_init(service_id);
 	if (rc != EOK)
 		return rc;
@@ -310,5 +311,5 @@
 
 	/* Initialize libblock */
-	rc = block_init(service_id, 4096);
+	rc = block_init(service_id);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/fs/udf/udf.h
===================================================================
--- uspace/srv/fs/udf/udf.h	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/srv/fs/udf/udf.h	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2008 Jakub Jermar
  * Copyright (c) 2012 Julia Medvedeva
@@ -51,6 +52,4 @@
 
 #define BS_BLOCK     0
-#define MIN_SIZE     512
-#define MAX_SIZE     8192
 #define DEFAULT_VOL  0
 
Index: uspace/srv/fs/udf/udf_ops.c
===================================================================
--- uspace/srv/fs/udf/udf_ops.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/srv/fs/udf/udf_ops.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2008 Jakub Jermar
  * Copyright (c) 2012 Julia Medvedeva
@@ -323,5 +324,5 @@
 
 	/* initialize block cache */
-	errno_t rc = block_init(service_id, MAX_SIZE);
+	errno_t rc = block_init(service_id);
 	if (rc != EOK) {
 		free(instance);
Index: uspace/srv/hid/console/console.c
===================================================================
--- uspace/srv/hid/console/console.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/srv/hid/console/console.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2023 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2011 Martin Decky
  * All rights reserved.
@@ -366,7 +366,13 @@
 {
 	cons_event_t event;
-
+	bool alt;
+	bool shift;
+
+	alt = (mods & KM_ALT) != 0 && (mods & (KM_CTRL | KM_SHIFT)) == 0;
+	shift = (mods & KM_SHIFT) != 0 && (mods & (KM_CTRL | KM_ALT)) == 0;
+
+	/* Switch console on Alt+Fn or Shift+Fn */
 	if ((key >= KC_F1) && (key <= KC_F1 + CONSOLE_COUNT) &&
-	    ((mods & KM_CTRL) == 0)) {
+	    (alt || shift)) {
 		cons_switch(key - KC_F1);
 	} else {
Index: uspace/srv/volsrv/empty.c
===================================================================
--- uspace/srv/volsrv/empty.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/srv/volsrv/empty.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2015 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -62,5 +62,5 @@
 	label_bd_t lbd;
 
-	rc = block_init(sid, 2048);
+	rc = block_init(sid);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Error opening "
@@ -83,5 +83,5 @@
 	label_bd_t lbd;
 
-	rc = block_init(sid, 2048);
+	rc = block_init(sid);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Error opening "
